Attribute VB_Name = "Utilities"
'************************************************************************
'
'       Windsway General Utilities Library
'       WICUtilities.bas
'       Version 0.90
'
' The initial developer of this Visual Basic code is < Victor Fraenckel>
' (vfraenc1@nycap.rr.com).
'
' Portions created by < Victor Fraenckel> are
' Copyright (C) 2002 < Windsway Instrument Company>.
'
'
'       Obtained through:
'
'       Windsway Instrument Company
'
' You may get the latest version of this file by email from
' Victor Fraenckel <vfraenc1@nycap.rr.com >
'
' The contents of this file are used with permission, subject to
' the Mozilla Public License Version 1.1 (the "License")' you may
' not use this file except in compliance with the License. You may
' obtain a copy of the License at
' http://www.mozilla.org/MPL/MPL-1.1.html
'
' Software distributed under the License is distributed on an
' "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
' implied. See the License for the specific language governing
' rights and limitations under the License.
''************************************************************************

'************************************************************************
'
' If you modify this file or correct mistakes, I would appreciate
' you dropping me an e-mail to let me know what you think of it and
' let me know about your bug fixes and any additions you have made.
' Reach me at vfraenc1@nycap.rr.com.
'
'Vic Fraenckel 08/26/2002
'
'************************************************************************

'************************************************************************
'  revision history
'   date        comment                                       who
'
' 08/26/03      began development                             vhf
'
'************************************************************************

'************************************************************************
'  module contains the following routines:
'
'   name        last modified date
' Tokenizer         08/26/02
'
'************************************************************************

Public Function Tokenizer(TString As String, _
                Token() As String, _
                Delimiters As String, _
                Optional IncludeEmpty As Boolean) As Long

'this function parses the string TString and places tokens found into the
'array Token(). Token delimiters are those defined in the string
'Delimiters. If empty tokens are to be included, the optional boolean
'IncludeEmpty must be set to true.

'this function returns UBound of array asTokem (zero based count of the
'tokens or -1 if TString contains no tokens.

'NOTE: the first token in the string TString will be at Token(0).
  
  Const BUFFERSIZE As Long = 1024
  
  Dim iPos As Long
  Dim cntToken As Long
  Dim posStart As Long
  Dim ubArray As Long
  
  ubArray = -1
  posStart = 1
  
  For iPos = 1 To Len(TString)
    ' is char among delimiters?
    If InStr(Delimiters, Mid$(TString, iPos, 1)) Then
      If iPos > posStart Or IncludeEmpty Then
        If cntToken > ubArray Then
          ubArray = ubArray + BUFFERSIZE
          ReDim Preserve Token(ubArray)
        End If
        ' cut token out of TString
        Token(cntToken) = Mid$(TString, posStart, iPos - posStart)
        cntToken = cntToken + 1
      End If
      posStart = iPos + 1
    End If
  Next
  ' remainder
  If iPos > posStart Or IncludeEmpty Then
    If cntToken > ubArray Then
      ReDim Preserve Token(cntToken)
    End If
    Token(cntToken) = Mid$(TString, posStart)
    cntToken = cntToken + 1
  End If
  
  ' erase or shrink
  If cntToken = 0 Then
    Erase Token
  Else
    ReDim Preserve Token(cntToken - 1)
  End If
  
  ' return ubound
  Tokenizer = cntToken - 1
  
End Function
